
#include "transformation.h"
#include "unix.h"
#include "x.h"
#include "xt.h"
#include <sys/time.h>
#include <sys/stat.h>

static void getTrans();
static void DestroyPopupPrompt();
static void Done();
static void Done2();
static void EnterCallback();
static void EditCallback();
static void getFileName();

typedef struct _Text {
    char *directory, *filename;
    String text2, text3;
} Text;

FILE *fptr, *flck, *fopen();
char *filelock;


makeTrans( widget, client_data, call_data )
Widget widget;
XtPointer client_data, call_data;
{
    Arg       args[5];
    Widget    title, popup, form;
    Widget    label0, label1, label2, label3;
    Widget    text1, text2, text3;
    Widget    enter, done, ok1, cancel, edit;
    Widget    rx, ry, rz, rxy, ryz, rzx, rxyz;
    Widget    tx, ty, tz, txy, tyz, tzx, txyz;
    Widget    sx, sy, sz, sxy, syz, szx, sxyz;
    Position  x, y;
    Dimension width, height;
    Cardinal  n;
    Text	  *text;
    int    i, slash;
    static String buffer;
    static String buffer1;
    extern char *getenv ();
    char * directory;
    char * filename = (char *) client_data;

    struct timeval	tp;
    struct timezone	tzp;
    struct stat		s_buf;

    if( filename == NULL ) {
        filename = (char *) malloc(18);
        strcpy( filename, "tmp" );
        gettimeofday( &tp, &tzp );
        buffer = (char *) malloc( 30 );
        sprintf( buffer, "%d.anim", (tp.tv_sec)%1000 );
        strcat( filename, buffer );
    }

    /* Seperate the directory from the filename */
    directory = (char *) malloc(strlen(getenv("OBJ_PATH"))+strlen(filename)+10);
    strcpy( directory, getenv("OBJ_PATH") );
    strcat( directory, "/" );
    strcat( directory, filename );

    /* if file exists */
    if ( !(stat( directory, &s_buf ) == -1) ) {
        gettimeofday( &tp, &tzp );
        buffer = (char *) malloc(10);
        sprintf( buffer, "%d.anim", (tp.tv_sec)%1000 );
        directory[strlen(directory)-5] = '\0';
        strcat( directory, buffer );
    }

    if( (fptr = fopen( directory, "w" )) == NULL ) {
        printf("Transformation file NULL\n");
        exit();
    }

    filelock = (char *) malloc( strlen(filename) + 1 );
    strcpy( filelock, filename );
    filelock[strlen(filelock)-4] = '\0';
    strcat( filelock, "lck" );

    if( (flck = fopen( filelock, "w" )) == NULL ) {
        printf("File lock file NULL\n");
        exit();
    }

    /*
     * This will position the upper left hand corner of the popup at the
     * center of the widget which invoked this callback, which will also
     * become the parent of the popup.  I don't deal with the possibility
     * that the popup will be all or partially off the edge of the screen.
     */
    n = 0;
    XtSetArg(args[n], XtNwidth, &width);   n++;
    XtSetArg(args[n], XtNheight, &height); n++;
    XtGetValues( widget, args, n);
    XtTranslateCoords( widget,
                       (Position)(width/2), (Position)(height/2), &x, &y );
    n = 0;
    XtSetArg(args[n], XtNx, x);   n++;
    XtSetArg(args[n], XtNy, y);   n++;

    /* allocate space for the info we will pass down to the callbacks */
    text = (Text *) malloc( sizeof (Text) );

/*  popup = XtCreatePopupShell( "prompt", transientShellWidgetClass, */
    popup = XtCreatePopupShell( "prompt", topLevelShellWidgetClass,
        widget, args, n );

    form = XtVaCreateManagedWidget( "form", formWidgetClass, popup, NULL );

    title = XtVaCreateManagedWidget( "title", labelWidgetClass, form, 
        NULL );

    label0 = XtVaCreateManagedWidget( "label0", labelWidgetClass, form, 
        NULL );
    label1 = XtVaCreateManagedWidget( "label1", labelWidgetClass, form, 
        NULL );

    buffer1 = (char *) malloc( 80 );
    sprintf( buffer1, "%s", directory );
    text->directory = XtNewString( buffer1 );

    buffer = (char *) malloc( 30 );
    sprintf( buffer, "%s", filename );
    text->filename = XtNewString( buffer );
    text1 = XtVaCreateManagedWidget( "text1", asciiTextWidgetClass, form,
        XtNeditType, XawtextEdit,
        XtNtype, XawAsciiString,
        XtNuseStringInPlace, True,
        XtNresizable, True,
        XtNresize, XawtextResizeWidth,
        XtNright, XtChainRight,
        XtNsensitive, False,
        XtNstring, text->filename,
        XtNlength, 30,
        XtNwidth, 11*strlen(buffer),
        XtNinsertPosition, strlen(buffer),
        NULL );

    rx   = XtVaCreateManagedWidget( "rot_x",   commandWidgetClass, form, NULL );
    ry   = XtVaCreateManagedWidget( "rot_y",   commandWidgetClass, form, NULL );
    rz   = XtVaCreateManagedWidget( "rot_z",   commandWidgetClass, form, NULL );
    rxy  = XtVaCreateManagedWidget( "rot_xy",  commandWidgetClass, form, NULL );
    ryz  = XtVaCreateManagedWidget( "rot_yz",  commandWidgetClass, form, NULL );
    rzx  = XtVaCreateManagedWidget( "rot_zx",  commandWidgetClass, form, NULL );
    rxyz = XtVaCreateManagedWidget( "rot_xyz", commandWidgetClass, form, NULL );

    XtAddCallback( rx,   XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( ry,   XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( rz,   XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( rxy,  XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( ryz,  XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( rzx,  XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( rxyz, XtNcallback, getTrans, (caddr_t)NULL );

    tx   = XtVaCreateManagedWidget( "trn_x",   commandWidgetClass, form, NULL );
    ty   = XtVaCreateManagedWidget( "trn_y",   commandWidgetClass, form, NULL );
    tz   = XtVaCreateManagedWidget( "trn_z",   commandWidgetClass, form, NULL );
    txy  = XtVaCreateManagedWidget( "trn_xy",  commandWidgetClass, form, NULL );
    tyz  = XtVaCreateManagedWidget( "trn_yz",  commandWidgetClass, form, NULL );
    tzx  = XtVaCreateManagedWidget( "trn_zx",  commandWidgetClass, form, NULL );
    txyz = XtVaCreateManagedWidget( "trn_xyz", commandWidgetClass, form, NULL );

    XtAddCallback( tx,   XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( ty,   XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( tz,   XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( txy,  XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( tyz,  XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( tzx,  XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( txyz, XtNcallback, getTrans, (caddr_t)NULL );

    sx   = XtVaCreateManagedWidget( "scl_x",   commandWidgetClass, form, NULL );
    sy   = XtVaCreateManagedWidget( "scl_y",   commandWidgetClass, form, NULL );
    sz   = XtVaCreateManagedWidget( "scl_z",   commandWidgetClass, form, NULL );
    sxy  = XtVaCreateManagedWidget( "scl_xy",  commandWidgetClass, form, NULL );
    syz  = XtVaCreateManagedWidget( "scl_yz",  commandWidgetClass, form, NULL );
    szx  = XtVaCreateManagedWidget( "scl_zx",  commandWidgetClass, form, NULL );
    sxyz = XtVaCreateManagedWidget( "scl_xyz", commandWidgetClass, form, NULL );

    XtAddCallback( sx,   XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( sy,   XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( sz,   XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( sxy,  XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( syz,  XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( szx,  XtNcallback, getTrans, (caddr_t)NULL );
    XtAddCallback( sxyz, XtNcallback, getTrans, (caddr_t)NULL );

    label2 = XtVaCreateManagedWidget( "label2", labelWidgetClass, form, NULL );
    buffer = (char *) malloc( 30 );
    sprintf( buffer, "0.00" );
    text->text2 = XtNewString( buffer );
    text2  = XtVaCreateManagedWidget( "text2", asciiTextWidgetClass, form,
        XtNeditType, XawtextEdit,
        XtNtype, XawAsciiString,
        XtNuseStringInPlace, True,
        XtNresizable, True,
        XtNresize, XawtextResizeWidth,
        XtNright, XtChainRight,
        XtNstring, text->text2,
        XtNlength, 5,
        XtNwidth, 11*(strlen(text->text2)+2),
        XtNinsertPosition, strlen(text->text2),
        NULL );

    label3 = XtVaCreateManagedWidget( "label3", labelWidgetClass, form, NULL );
    buffer = (char *) malloc( 30 );
    sprintf( buffer, "1" );
    text->text3 = XtNewString( buffer );
    text3  = XtVaCreateManagedWidget( "text3", asciiTextWidgetClass, form,
        XtNeditType, XawtextEdit,
        XtNtype, XawAsciiString,
        XtNuseStringInPlace, True,
        XtNresizable, True,
        XtNresize, XawtextResizeWidth,
        XtNright, XtChainRight,
        XtNstring, text->text3,
        XtNlength, 10,
        XtNwidth, 11*(strlen(text->text3)+2),
        XtNinsertPosition, strlen(text->text3),
        NULL );

    done = XtVaCreateManagedWidget( "done", commandWidgetClass, form, NULL );
    XtAddCallback( done, XtNcallback, Done, NULL );
/*
    cancel = XtVaCreateManagedWidget( "cancel", commandWidgetClass, form, NULL);
    XtAddCallback( cancel, XtNcallback, DestroyPopupPrompt, (caddr_t)form );
*/
    enter = XtVaCreateManagedWidget( "enter", commandWidgetClass, form, NULL );
    XtAddCallback( enter, XtNcallback, EnterCallback, (caddr_t)text );
/*
    ok1 = XtVaCreateManagedWidget( "ok1", commandWidgetClass, form, NULL );
    XtAddCallback( ok1, XtNcallback, getFileName, (caddr_t)text );

    edit = XtVaCreateManagedWidget( "edit", commandWidgetClass, form, NULL );
    XtAddCallback( edit, XtNcallback, EditCallback, NULL );
*/
    XtRealizeWidget( popup );
    XtPopup( popup, XtGrabNone );
}


static void
getTrans( widget, client_data, call_data )
Widget widget;
caddr_t client_data, call_data;
{
    char *transformation;
    Cardinal n;
    Arg args[2];
    Text *ptext;
    String buffer;
    int steps;
    float move;

    transformation = (char *) malloc(20);
    n=0;
    XtSetArg( args[0], XtNlabel, &transformation );    n++;
    XtGetValues( widget, args, n );

    fprintf( fptr, "%s\n", transformation );
}


/*        Function Name: DestroyPopupPrompt
 *        Description: Destroys the popup dialog widget.
 *        Returns: none.
 */

static void
DestroyPopupPrompt( widget, client_data, call_data )
Widget    widget;
caddr_t client_data, call_data;
{
    Widget popup = XtParent( (Widget)client_data );

    fclose( fptr );
    XtDestroyWidget(popup);
}

static void
Done( widget, client_data, call_data )
Widget widget;
caddr_t client_data, call_data;
{
#if( 0 ) 
    AnimScript *readTrans();
    AnimScript *scriptList;

    Widget popup = XtParent( XtParent( widget ) );

    scriptList = readTrans( filename );
    execute( scriptList );

    XtDestroyWidget(popup);
    XtPopdown( popup );
    XtUnmapWidget( popup );       /* instead of XtDestroyWidget( popup ); */
#endif		/*  */
    if( fptr != NULL ) fclose( fptr );
    if( flck != NULL ) {
        fclose( flck );
        if( remove( filelock ) )
            printf( "Did not remove file lock\n" );
    }

    XtDestroyWidget( XtParent( XtParent( widget ) ) );
}


static void 
EditCallback( widget, client_data, call_data )
Widget widget;
caddr_t client_data, call_data;
{
    Arg       args[5];
    Widget    popup1, form1, wtext, done2;
    Position  x, y;
    Dimension width, height;
    Cardinal  n;

    printf("got an EDIT call\n");
    n = 0;
    XtSetArg( args[n], XtNwidth, &width );   
    n++;
    XtSetArg( args[n], XtNheight, &height ); 
    n++;
    XtGetValues( widget, args, n );
    XtTranslateCoords( widget, (Position)(width/2),
        (Position)(height/2), &x,&y );
    n = 0;
    XtSetArg( args[n], XtNx, x );   n++;
    XtSetArg( args[n], XtNy, y );   n++;

    popup1 = XtCreatePopupShell( "prompt1", transientShellWidgetClass,
        widget, args, n );

    form1 = XtVaCreateManagedWidget( "form1", formWidgetClass, popup1, NULL );

    wtext = XtVaCreateManagedWidget( "wtext", asciiTextWidgetClass, form1, NULL );

    done2 = XtVaCreateManagedWidget( "done2", commandWidgetClass, form1, NULL );
    XtAddCallback( done2, XtNcallback, Done2, NULL );

    printf("DONE with it \n");
}


static void
Done2( widget, client_data, call_data )
Widget widget;
caddr_t client_data, call_data;
{
}

static void 
EnterCallback( widget, client_data, call_data )
Widget widget;
caddr_t client_data, call_data;
{
    Text *ptext;
    Cardinal n;
    String buffer;
    int steps;
    float move;

    ptext = (Text *)client_data;
    buffer = (String) malloc(30);

    strcpy( buffer, ptext->text2 );
/*  XtFree( ptext->text2 ); */
    sscanf( buffer, "%f", &move );
    strcpy( buffer, ptext->text3 );
/*  XtFree( ptext->text3 ); */
    sscanf( buffer, "%d", &steps );

    fprintf( fptr, "        %f    %d\n", move, steps );
    free( buffer );
}


static void
getFileName( widget, client_data, call_data )
Widget widget;
caddr_t client_data, call_data;
{
    Text *ptext;
    String filename, directory;

    ptext = (Text *)client_data;
    filename = (String) malloc(30);
    directory = (String) malloc(30);

    strcpy( filename, ptext->filename );
    strcpy( directory, ptext->directory );
    strcat( directory, filename );
    if( (fptr = fopen( directory, "a" )) == NULL ) {
        printf("Transformation file NULL\n");
        exit();
    }
}
