
#ifndef _defs_h
#define _defs_h

#define OBJECT_LABEL			(long)  1
#define AXIS_LABEL				(long)  2
#define WIREFRAME_LABEL			(long)  4
#define ROTATE_LABEL			(long)  5
#define SHADOW_ROTATE_LABEL		(long)  6
#define CULL_LABEL				(long)  8
#define SHADOW_LABEL			(long)  9

#define LIGHT_STATE_LABEL		(long) 11
#define INTERIOR_LABEL			(long) 12
#define SHADING_METHOD_LABEL	(long) 13
#define REFL_PROPS_LABEL		(long) 14
#define REFL_EQN_LABEL			(long) 15
#define MATERIAL_COLOR_LABEL	(long) 16
#define DEPTH_CUE_LABEL			(long) 21

/* Vertex Order information */
#define CLOCKWISE			1
#define COUNTERCLOCKWISE	2

/* Back Face information */
#define REVERSE				1
#define NORMAL				2

/* Drawable information */
#define WINDOW		1
#define PIXMAP		2
#define BUFFER		3

/* Light source parameters */
#define RED_COORD			1
#define GREEN_COORD			2
#define BLUE_COORD			3
#define ATTENUATION_C1		4
#define ATTENUATION_C2		5
#define SPREAD_ANGLE		6
#define CONCENTRATION		7
#define AMBIENT_COEF		8
#define DIFFUSE_COEF		9
#define TRANSMISSION_COEF	10
#define SPECULAR_COEF		11
#define SPECULAR_EXP		12

/* Light types */
#define AMBIENT			0
#define DIRECTIONAL		1
#define POSITIONAL		2
#define SPOT			3

/* Shadow plane types */
#define PEXXPlane   1
#define PEXYPlane   2
#define PEXZPlane   3

#define PEXLightLocal       1.
#define PEXLightInfinite    0.

#endif /* _defs_h */
