
#include "unix.h"
#include "off.h"
#include <X11/Intrinsic.h>
#ifndef USE_ATHENA
#include <Xm/Xm.h>
#else
#include <X11/StringDefs.h>
#endif


void
map_dialog(parent, xpos, ypos)
Widget parent;
Position *xpos, *ypos;
{
    Position x, y;
    Dimension w, h;
    Dimension width, height, border_width;
    Dimension rWidth, rHeight;
    int rx, ry, wx, wy;
    unsigned int mask;
    Window root, child;

    /*
     * This will position the upper left hand corner of the popup at the
     * center of the widget which invoked this callback, which will also
     * become the parent of the popup.  I don't deal with the possibility
     * that the popup will be all or partially off the edge of the screen.
     */
    XQueryPointer( XtDisplay( parent ), XtWindow( parent ),
                   &root, &child,
                   &rx, &ry, &wx, &wy, &mask );
    XtVaGetValues( parent,
#ifndef USE_ATHENA
                   XmNwidth, &width,
                   XmNheight, &height,
                   XmNborderWidth, &border_width,
#else
                   XtNwidth, &width,
                   XtNheight, &height,
                   XtNborderWidth, &border_width,
#endif
                   NULL );
    width  += border_width + border_width;
    height += border_width + border_width;
    x = rx - wx + width / 2;
    y = ry - wy + height / 2;
    rWidth = WidthOfScreen( XtScreen( parent ) );
    rHeight = HeightOfScreen( XtScreen( parent ) );
    if( (int)(x + width) > (int)rWidth ) x = rWidth - width;
    if( (int)(y + height) > (int)rHeight ) y = rHeight - height;
    if( x < 0 ) x = 0;
    if( y < 0 ) y = 0;
    *xpos = x;
    *ypos = y;
}
